<?php
/**
 * Sphider Version 5.5.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Installation
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
echo "<html>";
echo "<head>";
echo "<title>";
echo "Update version number to 5.5.1.";
echo "</title>";
echo "<LINK REL=STYLESHEET HREF='admin.css' TYPE='text/css'>";
echo "</head>";
echo "<body>";
echo "<h2>Update the database version number.</h2>";

//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);
$settings_dir = "../settings";
require "$settings_dir/database.php";

$error = 0;
$state = 0;
$ver_list = array(
    "3.2.0", "3.2.1", "3.3.0", "3.4.0", "3.4.1", "3.4.2", "3.4.3", "3.4.4", "3.4.5", "3.5.0", "3.5.1", "3.5.2", "3.5.3",
    "3.6.0", "3.6.1", "4.0.0", "4.0.1", "4.0.2", "4.1.0", "4.2.0", "4.2.1", "5.0.0", "5.1.0", "5.2.0", "5.2.1", "5.3.0",
    "5.4.0", "5.4.1", "5.5.0", "5.5.1"
);
$ver_count = count($ver_list);

$result = $db->query("SHOW TABLES LIKE '%settings'");
if ($result->num_rows < 1) {
    $state = 1;    // There is no settings table, unrecognized version
} else {
    $result = $db->query(
        "SELECT version_nr FROM ".$mysql_table_prefix
        ."settings WHERE id = 1"
    );
    $row = $result->fetch_row();
    for ($i = 0; $i < $ver_count; $i++) {
        if (strcmp($ver_list[$i], $row[0]) === 0) {
            $state = 2;    // We have found the version number
            break;
        }
    }
}

if (!$state == 2) {    // There is no settings table, or unrecognized version
    echo "Version unrecognized or not supported.<br>";
    echo "New install recommended.";
    echo "</body>";
    echo "</html>";
    exit;
}
if ($i == 27) {    // Indicated version is 5.4.1
    $result = $db->query("SHOW COLUMNS FROM `settings` LIKE 'dec_separator'");
    $exists = $result->num_rows;
    if ($exists == 1) {    // Version found is actually 5.5.0
	    $i++;
    }
}

switch ($i) {
case 0:
case 1: 
case 2:
case 3:
case 4:
case 5:
case 6:
case 7:
case 8:
case 9:
case 10:
case 11:
case 12:
case 13:
case 14:
case 15:
case 16:
case 17:
    echo "Badly outdated database.<br>";
    echo "New install recommended.";
    echo "</body>";
    echo "</html>";
    exit;
case 18:
    update420();
case 19:
    update421();
case 20:
    update500();
case 21:
    update510();
case 22:
    update520();
case 23:
    update521();
case 24:
    update530();
case 25:
    update540();
case 26:
    update541();
case 27;
    update550();
case 28:
    update551();
    break;
default:
    echo "You already have the latest version installed.<br>"
         ."Go to <a href='admin.php'>admin.php</a> to start indexing.</b>"; 
    echo "</body>";
    echo "</html>";
    exit;
}

if ($error >0) {
    print "<b>Updating the database failed. Consult the above error messages.</b>";
    echo "</body>";
    echo "</html>";
    exit;
} else {
    echo "<b>You have successfully updated the database to version ".$ver
    .". Go to <a href='admin.php'>admin.php</a> to start indexing.</b>"; 
}

echo "</body>";
echo "</html>";

/***********************************************************************************************/
/*                                          FUNCTIONS                                          */
/***********************************************************************************************/

/**
 * Update to version 4.2.0
 *
 * @return void
 */
function update420()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Modify description in links table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix."links
        MODIFY COLUMN description text"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.2.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.2.0";
}

/**
 * Update to version 4.2.1
 *
 * @return void
 */
function update421()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.2.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.2.1";
}

/**
 * Update to version 5.0.0
 *
 * @return void
 */
function update500()
{
    global $db, $mysql_table_prefix, $error, $ver;

    $db->query(
        "ALTER TABLE `".$mysql_table_prefix
        ."sites` ADD link_log bool DEFAULT '0'"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.0.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.0.0";
}

/**
 * Update to version 5.1.0
 *
 * @return void
 */
function update510()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.1.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.1.0";
}

/**
 * Update to version 5.2.1
 *
 * @return void
 */
function update521()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.2.1',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.2.1";
}

/**
 * Update to version 5.2.0
 *
 * @return void
 */
function update520()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.2.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.2.0";
}

/**
 * Update to version 5.3.0
 *
 * @return void
 */
function update530()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.3.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.3.0";
}

/**
 * Update to version 5.4.0
 *
 * @return void
 */
function update540()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Create new column pandoc_path in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pandoc_path VARCHAR(45) NULL DEFAULT NULL
        AFTER catppt_path"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_ in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_ INT NULL DEFAULT NULL
        AFTER min_delay"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_time in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_time INT NULL DEFAULT NULL
        AFTER pause_"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_time in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_pages INT NULL DEFAULT NULL
        AFTER pause_time"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column cft_lang in sites table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."sites ADD COLUMN ct_lang VARCHAR(10) NOT NULL DEFAULT 'en'
        AFTER link_log"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.4.0',
        pandoc_path='/usr/bin/pandoc',
        pause_='0',
        pause_time='120',
        pause_pages='30'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.4.0";
}

/**
 * Update to version 5.4.1
 *
 * @return void
 */
function update541()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.4.1',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.4.1";
}

/**
 * Update to version 5.5.0
 *
 * @return void
 */
function update550()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Change column 'language' to 'slanguage'
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings CHANGE COLUMN language slanguage VARCHAR(5) NULL DEFAULT NULL"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    
    // Create new column dec_separator in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN dec_separator VARCHAR(2) NULL DEFAULT NULL
        AFTER index_decimals"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.5.0',
        dec_separator='.'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.5.0";
}

/**
 * Update to version 5.5.1
 *
 * @return void
 */
function update551()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.5.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.5.1";

}
